#ifndef CLOCKANDTEMP_H
#define CLOCKANDTEMP_H
#include <stdint.h>
#include <time.h>

//Create Port interface
int CreatePort(void);
//Set Port interface
int SetLCDPort(void);
//Check what module is connected
void ReadDisplayModule(void);
//Clears the customer data on the display
void ClearCustomerData(void);
//Searches and retrieves the DOW device address
void SearchForDowAddress(uint8_t deviceAddress[]);
//Sends command ROMs to proper device address to read temperature
int8_t ReadTemperatureProbe(uint8_t deviceAddress[]);
//Display's the current temperature and the max temperature measured
void DisplayTemperatureReading( int8_t currentTemperature, int8_t allTimeMaxTemperature);
//Check to see if an alltime max or a session max has been measured
int8_t CheckMaxTemperature(int8_t *currentTemperature, int8_t *allTimeMaxTemperature);
//Save the all time max temperature
void SaveAllTimeMaxTemperature(int8_t *allTimeMaxTemperature);
//Display the Alltime max temperature alert
void DisplayAllTimeMaxTemperature(int8_t allTimeMaxTemperature);
//Get the current time
time_t GetTime(uint8_t *seconds, uint8_t *minutes, uint8_t *hours, char *amPm);
//Get the current date
void GetDate(char day[], char date[]);
//Write Display the current time onscreen
void DisplayTime(uint8_t seconds, uint8_t minutes, uint8_t hours, char amPm[]);
//Erase Day if day has changed
void EraseDay(char day[], char previousDay[]);
//Write the current date onscreen
void DisplayDate(char day[], char date[], char previousDay[]);
//Draw a colon for the onscreen clock.
void DrawColon(void);

#endif