#ifndef ALPHADRIVER_H
#define ALPHADRIVER_H
#include "AlphaInterface.h"
#define SHORT_TO_BYTE(x) (x & 0xFF), (x >> 8)
 void RawDecimalData(void);
 void RawHexData(void);
 void WriteString(char *data);
 void ChangeBaudRate(uint8_t speed);
 void ChangeI2CSlaveAddress(uint8_t address);
 void TransmissionProtocolSelect(uint8_t protocol);
 void SetaNonStandardBaudRate(short speed);
 uint32_t SoftwareReset(uint8_t data[], uint32_t length);
 void ClearScreen(void);
 void ChangetheStartUpScreen(uint8_t uint8_tacters[], uint32_t length);
 void AutoScrollOn(void);
 void AutoScrollOff(void);
 void SetAutoLineWrapOn(void);
 void SetAutoLineWrapOff(void);
 void SetCursorPosition(uint8_t row, uint8_t column);
 void GoHome(void);
 void MoveCursorBack(void);
 void MoveCursorForward(void);
 void UnderlineCursorOn(void);
 void UnderlineCursorOff(void);
 void BlinkingBlockCursorOn(void);
 void BlinkingBlockCursorOff(void);
 void CreateaCustomuint8_tacter(uint8_t data[], uint32_t length, uint8_t id);
 void SaveCustomuint8_tacters(uint8_t data[], uint32_t length, uint8_t id, uint8_t bank);
 void LoadCustomuint8_tacters(uint8_t bank);
 void SaveStartUpScreenCustomuint8_tacters(uint8_t data[], uint32_t length, uint8_t id);
 void InitializeMediumNumbers(void);
 void PlaceMediumNumbers(uint8_t digit, uint8_t column, uint8_t row);
 void InitializeLargeNumbers(void);
 void PlaceLargeNumbers(uint8_t digit, uint8_t column);
 void InitializeHorizontalBar(void);
 void PlaceHorizontalBarGraph(uint8_t length, uint8_t direction, uint8_t row, uint8_t column);
 void InitializeNarrowVerticalBar(void);
 void InitializeWideVerticalBar(void);
 void PlaceVerticalBar(uint8_t length, uint8_t column);
 void GeneralPurposeOutputOn(uint8_t number);
 void GeneralPurposeOutputOff(uint8_t number);
 void SetStartUpGPOState(uint8_t state, uint8_t number);
 void SetLEDIndicators(uint8_t colour, uint8_t number);
 uint32_t SearchforaOneWireDevice(uint8_t data[], uint32_t length);
 void DallasOneWireTransaction(uint8_t data[], uint32_t length, uint8_t receivebits, uint8_t sendbits, uint8_t flags);
 void ActivatePiezoBuzzer(uint8_t time);
 void SetKeypadBuzzerBeep(uint8_t setting);
 void AutoTransmitKeyPressesOn(void);
 void AutoTransmitKeyPressesOff(void);
 uint32_t PollKeyPress(uint8_t data[], uint32_t length);
 void ClearKeyBuffer(void);
 void SetDebounceTime(uint8_t time);
 void SetAutoRepeatMode(uint8_t mode);
 void AutoRepeatModeOff(void);
 void AssignKeypadCodes(uint8_t keyup[], uint8_t keydown[], uint32_t length);
 void KeypadBacklightOff(void);
 void SetKeypadBrightness(uint8_t brightness);
 void SetAutoBacklight(uint8_t setting);
 void BacklightOn(uint8_t minutes);
 void BacklightOff(void);
 void SetBrightness(uint8_t brightness);
 void SetandSaveBrightness(uint8_t brightness);
 void SetBacklightColour(uint8_t red, uint8_t green, uint8_t blue);
 void SetContrast(uint8_t contrast);
 void SetandSaveContrast(uint8_t contrast);
 void SetVFDBrightness(uint8_t brightness);
 void SetandSaveVFDBrightness(uint8_t brightness);
 void SetRemember(uint8_t setting);
 void SetDataLock(uint8_t level);
 void SetandSaveDataLock(uint8_t level);
 void WriteCustomerData(uint8_t data[], uint32_t length);
 uint32_t ReadCustomerData(uint8_t data[], uint32_t length);
 uint32_t ReadVersionNumber(uint8_t data[], uint32_t length);
 uint32_t ReadModuleType(uint8_t data[], uint32_t length);
 void InitializaTextWindow(uint8_t id, uint8_t x1, uint8_t y1, uint8_t x2, uint8_t y2, uint8_t fontX, uint8_t font, uint8_t Charspacing, uint8_t linespace, uint8_t scroll);
 void SetWindow(uint8_t id);
 void ClearTextWindow(uint8_t id);
 void DrawRectangle(uint8_t colour, uint8_t x1, uint8_t y1, uint8_t x2, uint8_t y2);
 void DrawLine(uint8_t x1, uint8_t y1, uint8_t x2, uint8_t y2);
#endif
